Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jdbc.core
Class BeanPropertyRowMapper

    java.lang.Object
      org.springframework.jdbc.core.BeanPropertyRowMapper

All Implemented Interfaces:
  RowMapper

Direct Known Subclasses:
  ParameterizedBeanPropertyRowMapper

    public class BeanPropertyRowMapper

extends Object
implements RowMapper

`RowMapper` implementation that converts a row into a new instance of the specified mapped target class. The mapped target class must be a top-level class and it must have a default or no-arg constructor.

Column values are mapped based on matching the column name as obtained from result set metadata to public setters for the corresponding properties. The names are matched either directly or by transforming a name separating the parts with underscores to the same name using "camel" case.

Mapping is provided for fields in the target class for many common types, e.g.: String, boolean, Boolean, byte, Byte, short, Short, int, Integer, long, Long, float, Float, double, Double, BigDecimal, `java.util.Date`, etc.

To facilitate mapping between columns and fields that don't have matching names, try using column aliases in the SQL statement like "select fname as first_name from customer".

Please note that this class is designed to provide convenience rather than high performance. For best performance consider using a custom RowMapper.

Since:
  2.5
Author:
  Thomas Risberg, Juergen Hoeller

Field Summary
`protected Log` | `logger` Logger available to subclasses
`protected Class` | `mappedClass` The class we are mapping to

Constructor Summary
`BeanPropertyRowMapper()` Create a new BeanPropertyRowMapper.
`BeanPropertyRowMapper(Class mappedClass)` Create a new BeanPropertyRowMapper.

Method Summary
`protected Object` | `getColumnValue(ResultSet rs, int index, PropertyDescriptor pd)` Retrieve a JDBC object value for the specified column.
`Class` | `getMappedClass()` Get the class that we are mapping to.
`protected void` | `initBeanWrapper(BeanWrapper bw)` Initialize the given BeanWrapper to be used for row mapping.
`protected void` | `initialize(Class mappedClass)` Initialize the mapping metadata for the given class.
`Object` | `mapRow(ResultSet rs, int rowNumber)` Extract the values for all columns in the current row.
`void` | `setMappedClass(Class mappedClass)` Set the class that each row should be mapped to.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final Log logger

  Logger available to subclasses

### mappedClass

    protected Class mappedClass

  The class we are mapping to

Constructor Detail

### BeanPropertyRowMapper

    public BeanPropertyRowMapper()

  Create a new BeanPropertyRowMapper.

  See Also:
    `setMappedClass(java.lang.Class)`

### BeanPropertyRowMapper

    public BeanPropertyRowMapper(Class mappedClass)

  Create a new BeanPropertyRowMapper.

  Parameters:
    `mappedClass` - the class that each row should be mapped to.

Method Detail

### setMappedClass

    public void setMappedClass(Class mappedClass)

  Set the class that each row should be mapped to.

### initialize

    protected void initialize(Class mappedClass)

  Initialize the mapping metadata for the given class.

  Parameters:
    `mappedClass` - the mapped class.

### getMappedClass

    public final Class getMappedClass()

  Get the class that we are mapping to.

### mapRow

    public Object mapRow(ResultSet rs,
                         int rowNumber)
                  throws SQLException

  Extract the values for all columns in the current row.

  Utilizes public setters and result set metadata.

  Specified by:
    `mapRow` in interface `RowMapper`
  Parameters:
    `rs` - the ResultSet to map (pre-initialized for the current row)
    `rowNumber` - the number of the current row
  Returns:
    the result object for the current row
  Throws:
    `SQLException` - if a SQLException is encountered getting column values (that is, there's no need to catch SQLException)
  See Also:
    `ResultSetMetaData`

### initBeanWrapper

    protected void initBeanWrapper(BeanWrapper bw)

  Initialize the given BeanWrapper to be used for row mapping. To be called for each row.

  The default implementation is empty. Can be overridden in subclasses.

  Parameters:
    `bw` - the BeanWrapper to initialize

### getColumnValue

    protected Object getColumnValue(ResultSet rs,
                                    int index,
                                    PropertyDescriptor pd)
                             throws SQLException

  Retrieve a JDBC object value for the specified column.

  The default implementation calls `JdbcUtils.getResultSetValue(java.sql.ResultSet, int, Class)`. Subclasses may override this to check specific value types upfront, or to post-process values return from `getResultSetValue`.

  Parameters:
    `rs` - is the ResultSet holding the data
    `index` - is the column index
    `pd` - the bean property that each result object is expected to match (or `null` if none specified)
  Returns:
    the Object value
  Throws:
    `SQLException` - in case of extraction failure
  See Also:
    `JdbcUtils.getResultSetValue(java.sql.ResultSet, int, Class)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.